#include "Tools.h"

//##########################################################################################

//P(X = k) if X~Poisson(par)

double poiss(int k, double par)
{ 
  double l,p,s;
  int i;

  l=log(par);
 
  if (k==0)
    { 
      p=exp(-par);
    }
  else
    { 
      s=0;
      for (i=1;i<=k;i++)
	{
	  s=s+log(double(i));
	}  
      p=exp(-par+k*l-s);
    }
  return p; 
}

//##########################################################################################

//P(d<=X<=a) if X~Poisson(par)

double sum_app(int d, double a, double par)
{ 
  int i,k;
  double s,l,p,pk;
  l=log(par);
  if (a<d)
    {
      cout<<endl<<"Erreur : on somme de "<<d<<"  "<<a<<"."<<endl;
      return 0;
    }
  if (d==0)
    { 
      s=0;
      p=exp(-par);
      pk=1;
      k=1;
      while ((k<=a)&&(pk>pow(double(10),double(-300))))
	{   
	  s=s+log(double(k));
	  pk=exp(k*l-par-s);
	  p=p+pk;    
	  k++;
	}     
    }
  else
    { 
      s=0;
      for (i=1;i<=d;i++)
	{
	  s=s+log(double(i));
	}  
      p=0;
      pk=1;
      k=d;   
      while ((k<=a)&&(pk>pow(double(10),double(-300))))
	{   	 
	  pk=exp(k*l-par-s);
	  p=p+pk;    
	  k++;
	  s=s+log(double(k));
	}
    }
  p=p+(a-k+1)*pow(double(10),double(-300));
  return p; 
}

//##########################################################################################

//sup of a table of size n

double sup (double* T, int n)
{
  int i=0;
  double sup = T[0];
  while (i<n)
    {
      if (T[i]>sup)
	{
	  sup=T[i];
	}
      i++;
    }
  return sup;
}

//##########################################################################################

//inf of a table of size n

double inf (double* T, int n)
{
  int i=0;
  double inf = T[0];
  while (i<n)
    {
      if (T[i]<inf)
	{
	  inf=T[i];
	}
      i++;
    }
  return inf;
}

//##########################################################################################

//Return 1 if the word A of size n belong to Bn(2)

int inBn2(char* A, int n)
{
  int p,i,s;
  for (p=1;p<=n/2;p++)
    {
      s=0;
      for(i=0;i<n-p;i++)
	{
	  s=s+(A[i]==A[i+p]);
	}
      if (s==n-p)
	{
	  return 1;
	}
    }
  return 0;
}

//##########################################################################################

//Return 1 if the word A od size n is not self overlapping

int no_overlap(char* A, int n)
{
  int p,i,s;
  for (p=1;p<n;p++)
    {
      s=0;
      for(i=0;i<n-p;i++)
	{
	  s=s+(A[i]==A[i+p]);
	}
      if (s==n-p)
	{
	  return 0;
	}
    }
  return 1;
}

//##########################################################################################

//Periods of a word :
//pp : principal period
//nA and rA : see "Stats..." of Abadi

int periods(char* A, int n, int &pp, int &nA, int &rA )
{
  int p,i,s;
  int * T = new int[n];
  for (p=1;p<=n;p++)
    {
      s=0;
      for(i=0;i<n-p;i++)
	{
	  s=s+(A[i]==A[i+p]);
	}
      if (s==n-p)
	{
	  T[p-1]=1;
	}
      else
	{
	  T[p-1]=0;
	}
    }
 
  //Principal period 
  pp=0;
   int fin=0;
   for(i=0;(i<n)&&(fin==0);i++)
     {
       if(T[i]==0)
 	{
 	  pp++;
 	}
       else
 	{
 	  fin=1;
 	}
     }
   pp++;
  
  int ppd=(n/pp)*pp; //(last principal period)

  //Number of secondar periods
  rA=0;
  for(i=ppd;i<n-1;i++)
    {
      if(T[i]==1)
	{
	  rA++;
	}
    } 
  if(rA!=0)
    {
      //First secondar period
      nA=ppd;
      while(T[nA]==0)
	{
	  nA++;
	}
      nA++;
    }
  else
    {
      nA=n;
    }
  return 1;
}
