#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include "Eispack.h"

#define min(a,b)	(((a) < (b)) ? (a) : (b))
#define max(a,b)	(((a) > (b)) ? (a) : (b))
#define FALSE 0
#define TRUE 1

/*the same as scilab method spec, extract eigenvalues of M by the 
Hessenberg method stored in eigenr and eigeni (real and imaginary parts)*/
void GetEigen(int n,double **M, double *eigenr, double *eigeni,int *ierr)
{
  double **z = (double**) malloc(n* sizeof(double*)) ;
 double *scale= (double*) malloc(n* sizeof(double)) ;
 int *intch= (int*) malloc(n* sizeof(int)) ;
 int lo,hi,i;
 for(i=0; i<n; i++) 
   z[i] = (double*) calloc(n,sizeof(double)) ;

 //cout << "Calcul de la matrice \"balance\"\n" ;
 balanc(M,n,&lo,&hi,scale) ;
 //cout << "Calcul de la matrice de Hessenberg\n" ;
 elmhes(M,n,lo,hi,intch);
 //cout << "Mthode HQR pour la diagonalisation de la matrice\n";
 hqr(n,lo,hi,M,eigenr,eigeni,ierr) ;
 free(scale) ;
  for(i=0; i<n; i++) free(z[i]); free(z) ;
 free(intch) ;
}

void balanc(double **a,int n, int *lo, int *hi, double scale[])
{
/* This routine is a translation of the Algol procedure from
 * Handbook for Automatic Computation, vol. II, Linear Algebra,
 * by Wilkinson and Reinsch, Springer-Verlag.
 */
    double c,f,g,r,s,radix,b2,dtmp;
	int i,j,k,l,noconv;
	
	radix = 2.0;
	b2 = radix * radix;
	l = 0;
	k = n-1;
	
/* Search for rows isolating an eigenvalue and push them down. */
L1:
	if (k == 0) {
		*lo = l;
		*hi = k;
		return;
	}
	for (j = k; j >= 0; j--) {
		r = 0;
		for (i = 0; i <= k; i++) {
			if (i == j) continue;
			if (a[j][i] != 0.0) r = 1;
		}
		if (r == 0) {
			scale[k] = j;
			if (j != k) {
                for (i = 0; i <= k; i++) {
                    dtmp = a[i][j];
                    a[i][j] = a[i][k];
                    a[i][k] = dtmp;
                }
                for (i = l;i < n; i++) {
                    dtmp = a[j][i];
                    a[j][i] = a[k][i];
                    a[k][i] = dtmp;
                }
			}	
			k--;
			goto L1;
		}
	}
/* Search for columns isolating an eigenvalue and push them left. */
L2:
	for (j = l; j <= k; j++) {
		c = 0;
		for (i = l; i <= k; i++) {
			if (i == j) continue;
			if (a[i][j] != 0.0) c = 1;
		}
		if (c == 0) {
			scale[l] = j;
			if (j != l) {
                for (i = 0; i <= k; i++) {
                    dtmp = a[i][j];
                    a[i][j] = a[i][l];
                    a[i][l] = dtmp;
                }
                for (i = l;i < n; i++) {
                    dtmp = a[j][i];
                    a[j][i] = a[l][i];
                    a[l][i] = dtmp;
                }
			}
			l++;
			goto L2;
		}
	}
/* Now balance the submatrix in rows l through k. */
	*lo = l;
	*hi = k;
	for (i = l; i <= k; i++)
		scale[i] = 1.0;
iteration:
	noconv = FALSE;
	for (i = l; i <= k; i++) {
		c = 0.0;
		r = 0.0;
		for (j = l; j <= k; j++) {
			if (j == i) continue;
            c += fabs(a[j][i]);
            r += fabs(a[i][j]);
		}
/* Guard against zero c or r due to underflow. (In FORTRAN version only!) */
		if ((c == 0.0) || (r == 0.0)) continue;
		g = r / radix;
		f = 1.0;
		s = c + r;
L3:
		while (c < g) {
			f *= radix;
			c *= b2;
		}
		g = r * radix;
L4:
		while (c >= g) {
			f /= radix;
			c /= b2;
		}
/* The preceding lines may be replaced by a machine language procedure
 * computing the exponent sig such that 
 *	sqrt(r/(c * radix)) <= radix^sig < sqrt(r*radix)/c).
 * Now balance.
 */
 		if (((c + r)/f) < (0.95 * s)) {
 			g = 1.0 / f;
 			scale[i] *= f;
 			noconv = TRUE;
 			for (j = l; j < n; j++) 
 				a[i][j] *= g;
 			for (j = 0; j <= k; j++)
 				a[j][i] *= f;
 		}
/* The j loops may be done by exponent modification in machine language. */
	}
	if (noconv) goto iteration;
}


void balbak(int n,int lo, int hi, double *scale,int m,double **z)
{
/* This routine is a translation of the Algol procedure from
 * Handbook for Automatic Computation, vol. II, Linear Algebra,
 * by Wilkinson and Reinsch, Springer-Verlag.
 */
	double s;
	int i,j,k,ii;

	m--;		/* m is handled as a FORTRAN index variable */
	if (m == 0)
		goto _200;
	if (hi == lo) goto _120;
	for(i = lo; i <= hi; i++) {
		s = scale[i];

/* Left hand eigenvectors are back transformed if the foregoing
 * statement is replaced by s = 1.0 / scale[i] ...
 */
 		for (j = 0; j <= m; j++)
 			z[i][j] *= s;
 	}
 _120:
 	for (ii = 0; ii < n; ii++) {
 		i = ii;
 		if ((i >= lo) && ( i <= hi))
 			goto _140;
 		if (i < lo)
 			i = lo - ii;
 		k = (int) scale[i];
 		if (k == i)
 			goto _140;
 		for (j = 0;  j <= m; j++) {
 			s = z[i][j];
 			z[i][j] = z[k][j];
 			z[k][j] = s;
 		}
	_140: ;
	}
 _200:	;
}


void elmbak(int lo, int hi, double **a,int intch[],int m,double **z)
{
/* This routine is a translation of the Algol procedure from
 * Handbook for Automatic Computation, vol. II, Linear Algebra,
 * by Wilkinson and Reinsch, Springer-Verlag.
 */
	double x;
	int i,j,kp1,la,mm,mp,mp1;
	
	if (m == 0)
		goto _200;
	la = hi - 1;
	kp1 = lo + 1;
	if (la < kp1)
		goto _200;
	for (mm = kp1; mm <= hi; mm++) {
		mp = lo + hi - mm;
		mp1 = mp + 1;
		for (i = mp1;i <= hi; i++) {
			x = a[i][mp-1];
			if (x == 0.0)
				goto _110;
			for (j = 0; j <= m; j++)
				z[i][j] += (x * z[mp][j]);
		_110:;
		}
		i = intch[mp];
		if (i == mp)
			goto _140;
		for (j = 0; j <= m; j++) {
			x = z[i][j];
			z[i][j] = z[mp][j];
			z[mp][j] = x;
		}
	_140:;
	}
 _200:;
}


void elmhes(double **a,int n, int lo, int hi, int *intch)
{
/* This routine is a translation of the Algol procedure from
 * Handbook for Automatic Computation, vol. II, Linear Algebra,
 * by Wilkinson and Reinsch, Springer-Verlag.
 */
    double x,y,dtmp;
	int i,j,kp1,la,m,mm1,mp1;
	
	la = hi - 1;
	kp1 = lo + 1;
	if (la < kp1)
		goto _200;
	for (m = kp1; m <= la; m++) {
		mm1 = m - 1;
		x = 0;
		i = m;
		for (j = m; j <= hi; j++) {
            if (fabs(a[j][mm1]) <= fabs(x))
				goto _100;
			x = a[j][mm1];
			i = j;
		_100:;
		}
		intch[m] = i;
		if (i == m)
			goto _130;

/* Interchange rows and columns of array a. */
        for (j = mm1; j < n; j++) {
            dtmp = a[i][j];
            a[i][j] = a[m][j];
            a[m][j] = dtmp;
        }
        for (j = 0; j <= hi; j++) {
            dtmp = a[j][i];
            a[j][i] = a[j][m];
            a[j][m] = dtmp;
        }
	_130: ;
		if (x == 0.0)
			goto _180;
		mp1 = m + 1;
		for (i = mp1; i <= hi;i++) {
			y = a[i][mm1];
			if (y == 0)
				goto _160;
			y /= x;
			a[i][mm1] = y;
			for (j = m; j < n; j++)
				a[i][j] -= y * a[m][j];
			for (j = 0; j <=hi; j++)
				a[j][m] += y * a[j][i];
		_160: ;
		} /* endfor  i */ 
	_180: ;
	} /* endfor m */
 _200:;
}



void eltran(int n, int lo, int hi, double **a,int intch[],double **z)
{
/* This routine is a translation of the Algol procedure from
 * Handbook for Automatic Computation, vol. II, Linear Algebra,
 * by Wilkinson and Reinsch, Springer-Verlag.
 */
	int i,j,kl,mm,mp,mp1;
	
/* Initialize z to identity matrix. */
	for (j = 0; j < n; j++) {
		for (i = 0; i < n; i++)
			z[i][j] = 0.0;
		z[j][j] = 1.0;
	}
	kl = hi - lo - 1;
	if (kl < 1)
		goto _200;
	for (mm = 1; mm <= kl; mm++) {
		mp = hi - mm;
		mp1 = mp + 1;
		for (i = mp1; i <= hi; i++) {
			z[i][mp] = a[i][mp-1];
		}
		i = intch[mp];
		if (i == mp)
			goto _140;
		for (j = mp; j <= hi; j++) {
			z[mp][j] = z[i][j];
			z[i][j] = 0.0;
		}
		z[i][mp] = 1.0;
	_140: ;
	}
 _200:;
}

	
 
void hqr(int n,int lo,int hi,double **h,double *wr,double *wi,int *ierr)
{
	double norm,p,q,r,s,t,tst1,tst2,w,x,y,zz;
	int en,enm2,i,itn,its,j,k,l,ll,m,mm,mp2,na,notlas;
	
	*ierr = 0;
	norm = 0.0;
	k = 0;		/* Used for array indexing. FORTRAN version: k=1 */
	
/* Store roots isolated by balance. */
	for (i = 0; i < n; i++) {
		for (j = k; j < n; j++)
            norm += fabs(h[i][j]);
		k = i;
		if ((i >= lo) && (i <= hi))			
			goto _50;
		wr[i] = h[i][i];
		wi[i] = 0.0;
	_50:;
	}
	en = hi;
	t = 0.0;
	itn = 30 * n;

/* Search for next eigenvalues. */
_60:
	if (en < lo) goto _1001;
	its = 0;
	na = en - 1;
	enm2 = na - 1;

/* Look for single small sub-diagonal element. */
_70:
	for (ll = lo;ll <= en; ll++) {
		l = en + lo - ll;
		if (l == lo) goto _100;
        s = fabs(h[l-1][l-1]) + fabs(h[l][l]);
		if (s == 0.0)
			s = norm;
		tst1 = s;
        tst2 = tst1 + fabs(h[l][l-1]);
		if (tst2 == tst1) goto _100;
	}

/* Form shift. */
_100:
	x = h[en][en];
	if (l == en)
		goto _270;
	y = h[na][na];
	w = h[en][na] * h[na][en];
	if (l == na)
		goto _280;
	if (itn == 0)
		goto _1000;
	if ((its != 10) && (its != 20))
		goto _130;		

/* Form exceptional shift. */
	t += x;
	for (i = lo; i <= en; i++)
		h[i][i] -= x;
    s = fabs(h[en][na]) + fabs(h[na][enm2]);
	x = 0.75 * s;
	y = x;
	w = -0.4375 * s * s;
_130:
	its++;
	itn--;
/* Look for two consecutive small sub-diagonal elements. */
	for (mm = l;mm <= enm2; mm++) {
		m = enm2 + l - mm;
		zz = h[m][m];
		r = x - zz;
		s = y - zz;
		p = (r * s - w) / h[m+1][m] + h[m][m+1];
		q = h[m+1][m+1] - zz - r - s;
		r = h[m+2][m+1];
        s = fabs(p) + fabs(q) + fabs(r);
		p /= s;
		q /= s;
		r /= s;
		if (m == l)
			goto _150;
        tst1 = fabs(p) * (fabs(h[m-1][m-1]) + fabs(zz) +
            fabs(h[m+1][m+1]));
        tst2 = tst1 + fabs(h[m][m-1]) * (fabs(q) + fabs(r));
		if (tst2 == tst1)
			goto _150;
	}
_150:
	mp2 = m + 2;
	for (i = mp2; i <= en; i++) {
		h[i][i-2] = 0.0;
		if (i == mp2)
			goto _160;
		
		h[i][i-3] = 0.0;
	_160:;
	}
/* Double QR step involving rows l to en and columns m to en. */
	for (k = m; k <= na; k++) {
		notlas = (k != na);
		if (k == m)
			goto _170;
		p = h[k][k-1];
		q = h[k+1][k-1];
		r = 0.0;
		if (notlas)
			r = h[k+2][k-1];
        x = fabs(p) + fabs(q) + fabs(r);
		if (x == 0.0)
			goto _260;
		p /= x;
		q /= x;
		r /= x;
_170:
        s = sqrt(p*p+q*q+r*r);
        if (p < 0.0) s = -s;
		if (k == m)
			goto _180;
		h[k][k-1] = -s * x;
		goto _190;
_180:
		if (l != m)
			h[k][k-1] = -h[k][k-1];
_190:
		p += s;
		x = p / s;
		y = q / s;
		zz = r / s;
		q /= p;
		r /= p;		
		if (notlas)
			goto _225;
/* Row modification. */
        for (j = k; j <= en; j++) {
			p = h[k][j] + q * h[k+1][j];
			h[k][j] -= (p * x);
			h[k+1][j] -= (p * y);
		}
		j = min(en,k+3);

/* Column modification. */
        for (i = l; i <= j; i++) {
			p = x * h[i][k] + y * h[i][k+1];
			h[i][k] -= p;
			h[i][k+1] -= (p * q);
		}
		goto _255;
_225:

/* Row modification. */
        for (j = k; j <= en; j++) {
			p = h[k][j] + q * h[k+1][j] + r * h[k+2][j];
			h[k][j] -= (p * x);
			h[k+1][j] -= (p * y);
			h[k+2][j] -= (p * zz);
		}
		j = min(en,k+3);
		
/* Column modification. */
        for (i = l; i <= j; i++) {
			p = x * h[i][k] + y * h[i][k+1] + zz * h[i][k+2];
			h[i][k] -= p;
			h[i][k+1] -= (p * q);
			h[i][k+2] -= (p * r);
		}
	_255:;
	_260:;
	}
		goto _70;
	
/* One root found. */
_270:
		wr[en] = x + t;
		wi[en] = 0.0;
		en = na;
		goto _60;

/* Two roots found. */
_280:
		p = (y - x) / 2.0;
		q = p * p + w;
        zz = sqrt(fabs(q));
		x += t;
		if ( q < 0.0)
			goto _320;

/* Real pair. */
        zz = fabs(zz);
        if (p < 0.0) zz = -zz;
        zz += p;
		wr[na] = x + zz;
		wr[en] = wr[na];
		if (zz != 0.0)
			wr[en] = x - w / zz;
		wi[na] = 0.0;
		wi[en] = 0.0;
		goto _330;

/* Complex pair. */
_320:
		wr[na] = x + p;
		wr[en] = x + p;
		wi[na] = zz;
		wi[en] = -zz;
_330:
		en = enm2;
		goto _60;
	
/* Set error -- all eigenvalues have not converged after 30*n iterations. */
_1000:
	*ierr = en;
_1001:
	return;
}
			

void pnormwr(int n,double **z,double *wr,double *wi)
{
    double emax,ei,t,xi,xr,yi,yr,zi,zr;
    int i,j,k;
	
    for (i=0;i < n;i++) {
        if (wi[i] == 0.0) {  /* eigenvector is real */
/* find max value in current column (eigenvector is column vector) */
            emax = 0.0;
            for (j = 0;j < n; j++) {
                    emax = max(fabs(z[j][i]),emax);
            } /* endfor j */
            if (emax != 0.0) {
/* rescale eigenvector for max amplitude = unity */
                emax = 1.0/emax;
                for (j = 0;j < n;j++) {
                    z[j][i] *= emax;
                } /* endfor j */
            } /* endif emax */
        } /* endif wi[i] = 0.0 (real entry) */
        else {  /* eigenvector is complex */
/* find max modulus and note location of corresponding element */
            emax = 0.0;
            k = 0;
            for (j = 0;j < n; j++) {
                xr = z[j][i];
                yr = z[j][i+1];
                xr = sqrt(xr*xr + yr*yr);
                if (xr > emax) {
                    emax = xr;
                    k = j;
                } /* endif xr */
            } /* endfor j */
            emax = z[k][i]; /* get re and im of element with max modulus */
            ei = z[k][i+1];

            for (j = 0;j < n; j++) {
/* rotate and scale each entry */
                yr = emax;
                yi = ei;
                xr = z[j][i];
                xi = z[j][i+1];
                if (fabs(yr) > fabs(yi)) {
                    t = yi / yr;
                    yr += t * yi;
                    zr = (xr + t * xi) / yr;
                    zi = (xi - t * xr) / yr;
                } /* endif */
                else {
                    t = yr / yi;
                    yi += t * yr;
                    zr = (t * xr + xi) / yi;
                    zi = (t * xi - xr) / yi;
                } /* endelse */
                z[j][i] = zr;
                z[j][i+1] = zi;
            } /* endfor j */
            i++;  /* complex value uses two columns */
        } /* endelse wi[i] != 0.0 (complex entry) */
    } /* endfor i */
    //    printmat(z,"Normalized eigenvectors",n);
} 
