#ifndef EISPACK_H
#define EISPACK_H

/**Adaptation of Eispack routines from fortran, for more information,
see on : 
http://www.psc.edu/general/software/packages/eispack/subroutines.html
**/

/*My (very little) addition, the same as scilab method spec, 
extract eigenvalues of M by the 
Hessenberg method stored in eigenr and eigeni (real and imaginary parts)*/
void GetEigen(int n,double **M, double *eigenr, double *eigeni,int *ierr);

/* balance matrix  and isolate eigenvalues whenever possible  */
void balanc(double **a,int n,int *low, int *high,double scale[]);

/* forms eigenvectors of matrix by back transformation  
those of the corresponding matrices determined by BALANC,
ans ELMHES.
*/
void balbak(int n,int low, int hi,double scale[],int m,double **z);

/* convert matrix to upper Hessenberg form */
void elmhes(double **a,int n,int lo, int hi,int intch[]);

/* accumulates stabilized similarity transformations 
Accumulate transformations used in the reduction to upper Hessenberg form
done by ELMHES */
void eltran(int n,int lo,int hi,double **a,int intch[],double **z);

/* forms eigenvectors by back transformation from elmhes */
void elmbak(int lo,int hi,double **a,int intch[],int m,double **z);

/* solve upper Hessenberg matrix for eigenvalues */
void hqr(int n,int lo,int hi,double **h,double *wr,double *wi,int *ierr);

/* solve upper Hessenberg matrix for eigenvalues and eigenvectors */
//NOT USED HERE, must change some options (gotos are the same in both methods
/* void hqr2(int n,int lo,int hi,double **h,double *wr, */
/* 	double *wi,double **z,int *ierr); */

void pnormwr(int n,double **z,double *wr,double *wi);

#endif 
