#include "Approx.h"

//#include <gsl/gsl_rng.h>
//#include <gsl/gsl_randist.h>
// For The GSL, previously installed

int loglevel = 3 ;
ofstream logstream;

// Commentary in the shell
int VERBOSE = 1;

//===========================================================================================
//===========================================================================================

//////////////////////
// LA FONCTION MAIN //
//////////////////////

//===========================================================================================

int main(int argc, char *argv[]) 
{  
  //Number of parameters in the command line
  int     num_arg=1 ; 
  //Matrix file  
  char  * matrix_file=NULL  ;
  //Words file
  char  * words_file=NULL  ;
  //Sequence file
  char  * sequence_file=NULL  ;
  //Alphabet file
  char  * alphabet_file=NULL  ;  
  //Result file
  char * result_file=NULL;
  //u file
  char * u_file=NULL;
  //order of the Markov model
  short order = -1;
  //Length of the sequence
  double length = -1;
  //Degree of significativity
  double ds = -1;
  //Error in k
  int in = -1;
  //sum errors from 0 to k
  int inf = -1;
  //sum errors from k to 2t/n
  int sup = -1;
  //sum errors from u to 2t/n
  int over = -1;
  //sum errors from 0 to u
  int under = -1;
  //Chen-Stein bound
  int cs=-1;
  //Count words in the sequence
  int ct=-1;
  //Man
  int h=-1;

  //========================================//
  // Back up of the parameters of execution //
  //========================================//

  while (num_arg < argc)
    {
      if ((strcmp (argv[num_arg], "-w") == 0) && (num_arg + 1 < argc))
	{
	  num_arg++ ;
	  words_file= argv[num_arg] ;
	  num_arg++ ;
	} 
      else 
	if (strcmp (argv[num_arg], "-o1") == 0)
	  {
	    num_arg++ ;
	    result_file= argv[num_arg] ;
	    num_arg++ ;
	  } 
	else 
	  if (strcmp (argv[num_arg], "-o2") == 0)
	    {
	      num_arg++ ;
	      u_file= argv[num_arg] ;
	      num_arg++ ;
	    } 
	  else 
	    if (strcmp (argv[num_arg], "-m") == 0)
	      {
		num_arg++ ;
		matrix_file= argv[num_arg] ;
		num_arg++ ;
	      } 
	    else 
	      if (strcmp (argv[num_arg], "-o") == 0)
		{
		  num_arg++ ;
		  order= atoi(argv[num_arg]); 
		  num_arg++ ;
		} 
	      else 
		if (strcmp (argv[num_arg], "-a") == 0)
		  {
		    num_arg++ ;
		    alphabet_file= argv[num_arg] ;
		    num_arg++ ;
		  } 
		else 
		  if (strcmp (argv[num_arg], "-s") == 0)
		    {
		      num_arg++ ;
		      sequence_file= argv[num_arg] ;
		      num_arg++ ;
		    } 
		  else 
		    if (strcmp (argv[num_arg], "-l") == 0)
		      {
			num_arg++ ;
			length= atof(argv[num_arg]) ;
			num_arg++ ;
		      }      
		    else 
		      if (strcmp (argv[num_arg], "-in") == 0)
			{
			  num_arg++ ;
			  in=atoi(argv[num_arg]);
			  num_arg++ ;
			} 
		      else 
			if (strcmp (argv[num_arg], "-inf") == 0)
			  {
			    num_arg++ ;
			    inf=atoi(argv[num_arg]);
			    num_arg++ ;
			  } 
			else 
			  if (strcmp (argv[num_arg], "-sup") == 0)
			    {
			      num_arg++ ;
			      sup=atoi(argv[num_arg]);
			      num_arg++ ;
			    } 
			  else 
			    if (strcmp (argv[num_arg], "-ds") == 0)
			      {
				num_arg++ ;
				ds = atof(argv[num_arg]);
				num_arg++ ;
			      }
			    else 
			      if (strcmp (argv[num_arg], "-over") == 0)
				{
				  num_arg++ ;
				  over=1;
				} 
			      else 
				if (strcmp (argv[num_arg], "-under") == 0)
				  {
				    num_arg++ ;
				    under=1;
				  } 
				else 
				  if (strcmp (argv[num_arg], "-cs") == 0)
				    {
				      num_arg++ ;
				      cs=1;
				    } 
				  else 
				    if (strcmp (argv[num_arg], "-ct") == 0)
				      {
					num_arg++ ;
					ct=1;
				      } 
				    else 
				      if (strcmp (argv[num_arg], "-h") == 0)
					{
					  num_arg++ ;
					  h=1;
					} 
				      else 
					if (strcmp (argv[num_arg], "-nv") == 0)
					  {
					    num_arg++ ;
					    VERBOSE=0;
					  }  						     
				      else 
					{
					  cerr<<endl;
					  cerr<<"\x1b[001;031m#######################\x1b[000m"<<endl
					      <<"\x1b[001;031m##### BAD OPTIONS #####\x1b[000m"<<endl
					      <<"\x1b[001;031m#######################\x1b[000m"<<endl
					      <<endl;
					  cerr << "Way to do : "<< argv[0]
					       << " -h for HELP"
					       <<endl<<endl
					       << "       or : "<< argv[0]
					       << " -o1 <result_file>"
					       << " [-o2 <u_file>]"
					       << " -w <words_file>"
					       << " -o <order>0>"
					       << " -a <alphabet_file>"
					       << " -m <matrix_file>"
					       << " -l <sequence_length>"
					       << " [-in <k>]"
					       << " [-inf <k>]"
					       << " [-sup <k>]"
					       << " [-ds <ds>]"
					       << " [-over]"
					       << " [-under]"				     
					       << " [-cs]"  
					       << " [-ct]"
					       << " [-nv]"
					       << " [-h]" 
					       << endl<<endl
					       << "       or : "<< argv[0]
					       << " -o1 <result_file>"
					       << " [-o2 <u_file>]"
					       << " -w <words_file>"
					       << " -o <order>0>"
					       << " -a <alphabet_file> "
					       << " -s <sequence_file>" 
					       << " [-in <k>]"
					       << " [-inf <k>]"
					       << " [-sup <k>]"
					       << " [-ds <ds>]"
					       << " [-over]"
					       << " [-under]"
					       << " [-cs]"  
					       << " [-ct]"
					       << " [-nv]" 
					       << " [-h]" 
					       <<endl<<endl;
					  return (1) ;
					}
    }

 
  if(h==1)
    {
      cout<<endl;
      cout<<"\x1b[001;031m##############################################################\x1b[000m"
	  <<endl
	  <<"\x1b[001;031m##########################          ##########################\x1b[000m"
	  <<endl
	  <<"\x1b[001;031m##########################   HELP   ##########################\x1b[000m"
	  <<endl
	  <<"\x1b[001;031m##########################          ##########################\x1b[000m"
	  <<endl
	  <<"\x1b[001;031m##############################################################\x1b[000m"
	  <<endl
	  <<endl;

      cout<<"Use 0:\x1b[001m PANOW -h\x1b[000m"
	  <<endl<<endl;

      cout<<"Use 1:\x1b[001m PANOW"
	  << " -o1 <rf>"
	  << " [-o2 <uf>]"
	  << " -w <wf>"
	  << " -o <ord>"
	  << " -a <af>"
	  << " -m <mf>"
	  << " -l <l>"
	  << " [-in <k>]"
	  << " [-inf <k>]"
	  << " [-sup <k>]"
	  << " [-ds <ds>]"
	  << " [-over]"
	  << " [-under]"				     
	  << " [-cs]"  
	  << " [-ct]"
	  << " [-nv]"
	  << " [-h]\x1b[000m" 
	  <<endl<<endl;

      cout<<"Use 2:\x1b[001m PANOW"
	  << " -o1 <rf>"
	  << " [-o2 <uf>]"
	  << " -w <wf>"
	  << " -o <ord>"
	  << " -a <af>"
	  << " -s <sf>"
	  << " [-in <k>]"
	  << " [-inf <k>]"
	  << " [-sup <k>]"
	  << " [-ds <ds>]"
	  << " [-over]"
	  << " [-under]"				     
	  << " [-cs]"  
	  << " [-ct]"
	  << " [-nv]"
	  << " [-h]\x1b[000m" 
	  <<endl<<endl;
      
      cout<<"=============================================================================="<<endl;
      cout<<"     PANOW (Poisson Approximation for the Number of Occurrences of Words)     "<<endl;
      cout<<"=============================================================================="<<endl;
      cout<<endl;
      cout<<"This program computes error between the law of the number of occurrences of a"<<endl; 
      cout<<"word in a Markov model and its Poisson approximation using point by point method."
	  <<endl;
      cout<<"This error is used to find rare words in biological sequences."<<endl;
      cout<<"This program compute the u from which a word can be considered as a rare word."
	  <<endl<<endl;
      cout<<"\x1b[001mThere is two ways to use the program :\x1b[000m"<<endl;
      cout<<"Use 1: Transition matrix is given with a length of sequence"<<endl;
      cout<<"Use 2: Transition matrix is estimated on the sequence"<<endl<<endl;

      cout<<"   -o1 <rf>         Result file containing the error terms."<<endl;
      cout<<"   -o2 <uf>         Result file containing the u computed by PANOW."<<endl;
      cout<<"                    Necessary for -over or -under or -cs or -ct option."<<endl;  
      cout<<"   -w <wf>          File containing words to study."<<endl;
      cout<<"   -o <ord>         Order of the Markov model."<<endl;
      cout<<"   -a <af>          A file describing the alphabet to use."<<endl;
      cout<<"   -m <mf>          A file containing the transition Matrix."<<endl;
      cout<<"                    Need to use -l option."<<endl;
      cout<<"                    Need to NOT use -s option."<<endl;     
      cout<<"   -l <l>           Length of the sequence."<<endl;
      cout<<"                    Necessary for -m option."<<endl;
      cout<<"   -s <sf>          A file containing file of sequence."<<endl;
      cout<<"                    Transition matrix is estimated on all the sequences."<<endl;
      cout<<"                    Need to NOT use -m or -l option."<<endl;
      cout<<"                    Necessary for -ct option."<<endl;
      cout<<"                    u computed for the total length of all the sequences of sf."<<endl;
      cout<<"   -in <k>          Compute error in k."<<endl;
      cout<<"   -inf <k>         Compute sum of errors under k."<<endl;
      cout<<"   -sup <k>         Compute sum of errors over k."<<endl;
      cout<<"   -ds <ds>         Degree of significativity."<<endl;
      cout<<"                    To find the u from which a word can be considered"<<endl;
      cout<<"                    as a rare words, you HAVE to fix a ds."<<endl;
      cout<<"                    Necessary for -over or -under or -cs option."<<endl;          
      cout<<"   -over            Compute the u from which a word can be consider"<<endl;
      cout<<"                    as a rare word : an overrepresented word."<<endl;
      cout<<"   -under           Compute the u from which a word can be consider"<<endl;
      cout<<"                    as a rare word : an undererrepresented word."<<endl;		     
      cout<<"   -cs              Compute Chen-Stein bound and the u from which"<<endl;
      cout<<"                    a word can be considered as a rare word :"<<endl;
      cout<<"                    an overerrepresented OR underrepresented word."<<endl;
      cout<<"                    Need -over or -under option."<<endl;
      cout<<"                    Need -ds option."<<endl;
      cout<<"   -ct              Count of words."<<endl;
      cout<<"                    Need -s option."<<endl;
      cout<<"   -nv              Mode not verbose. Nothing in the shell."<<endl;
      cout<<"   -h               Print this help and exit."<<endl;
      cout<<endl;

      cout<<"\x1b[001mThis program can return 5 different error messages:\x1b[000m"<<endl;
      cout<<"   1: \"This word do not satisfy hypothesis period greater than half of its length.\""
	  <<endl;
      cout<<"      It follows from the hypothesis of used Theorems."<<endl;
      cout<<"      See Poisson approximation in biological context, Vergne, N. and Abadi, M."<<endl; 
      cout<<"   2: \"p=0.  Transition matrix contains 0\""<<endl;
      cout<<"      Studied word has a null probability. Error is not computed."<<endl;
      cout<<"   3: \"Too large parameter\""<<endl;
      cout<<"      If the parameter of the Poisson law,tp(A), is greater than 500,"<<endl;
      cout<<"      error is not computable."<<endl; 
      cout<<"      t is the sequence length and p(A) the stationary probability of the word A."
	  <<endl;
      cout<<"      Then, for very short words in very long sequences, this method can not be used."
	  <<endl;
      cout<<"   4: \"Epsilon too large\""<<endl;
      cout<<"      For Epsilon greater than one, error increase with the number of occurrences."
	  <<endl;
      cout<<"      Then, method can not be used."<<endl;
      cout<<"   5: \"Impossible : "<<endl
	  <<"        a word of size n and of period greater than n/2"<<endl
	  <<"        can not appear k times in a sequence of length t"<<endl;
      cout<<"        No error, P(N = k) = 0.\""<<endl;
      cout<<"      If an impossible number of occurrences is required."<<endl;
      cout<<endl;
      return (1);
    }

  int error=0;
  if (alphabet_file == NULL)
    {
      cerr<<"-o1 <result_file> ?"<<endl;
      error=1;
    }
  if ((u_file == NULL) &&((cs==1)||(ct==1)||(over==1)||(under==1)))
    {
      cerr<<"-o2 <u_file> ?"<<endl;
      error=1;
    }
  if (words_file == NULL)
    {
      cerr<<"-w <words_file> ?"<<endl;
      error=1;
    }
  if (order <= 0)
    {
      cerr<<"-o <order>0> ?"<<endl;
      error=1;
    }
  if (alphabet_file == NULL)
    {
      cerr<<"-a <alphabet_file> ?"<<endl;
      error=1;
    }
  if (( matrix_file != NULL)&&( sequence_file != NULL))
    {
      cerr<<"-m and -s can not be used in same time"<<endl;
      cerr<<"Approx from -m <matrix_file> -l <sequence_length>0> or";
      cerr<<"Approx from -s <sequence_file> ?"<<endl;
      error=1;
    }
  if (( matrix_file == NULL)&&( sequence_file == NULL))
    {
      cerr<<"-m <matrix_file> -l <sequence_length>0> ? -s <sequence_file> ?"<<endl;
      error=1;
    }
  if (( matrix_file != NULL)&&( sequence_file == NULL)&&(length < 0))
    {
      cerr<<"-l <sequence_length>0> ?"<<endl;
      error=1;
    }
  if (( sequence_file != NULL)&&(length > 0))
    {
      cerr<<"no -l : length computed on the sequence file"<<endl;
      error=1;
    }
  if (( sequence_file == NULL)&&(ct==1))
    {
      cerr<<"-ct used : -s <sequence_file> ?"<<endl;
      error=1;
    }
  if ((cs==1)&&(over!=1)&&(under!=1))
    {
      cerr<<"-cs used : -over? -under?"<<endl;
      error=1;
    }
  if ((cs==1)&&(ds<0))
    {
      cerr<<"-ds <ds>0> ?"<<endl;
      error=1;
    }
  if (error == 1)
    {
      cerr<<endl;
      cerr<<"PANOW -h for help"<<endl<<endl;;
      return 1;
    }

  //==============================================//
  // GSL : Random Number Generator Initialization //
  //==============================================//

  const gsl_rng_type * T;
  gsl_rng * r;
      
  // Choice a default generator and seed
  // from environment variables
  gsl_rng_env_setup();
    
  // New created instance of the generator
  T = gsl_rng_default;
  r = gsl_rng_alloc (T);

  // Initialize/Seeds the random number generator
  gsl_rng_set( r, (long)(time( NULL )) );
  

  //=================================//
  // Mon programme en quelque sorte! //
  //=================================// 

  
  //Open result file
  ofstream fr;
  fr.open(result_file);
  
  if(VERBOSE)
    {
      cout<<endl;
      cout<<"\x1b[001;031m##############################################################\x1b[000m"
	  <<endl
	  <<"\x1b[001;031m##########################          ##########################\x1b[000m"
	  <<endl
	  <<"\x1b[001;031m##########################   MAIN   ##########################\x1b[000m"
	  <<endl
	  <<"\x1b[001;031m##########################          ##########################\x1b[000m"
	  <<endl
	  <<"\x1b[001;031m##############################################################\x1b[000m"
	  <<endl
	  <<endl;
    }
  fr<<endl
    <<"##############################################################"<<endl
    <<"##########################          ##########################"<<endl
    <<"##########################   MAIN   ##########################"<<endl
    <<"##########################          ##########################"<<endl
    <<"##############################################################"<<endl
    <<endl;

  
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@  TWO WAYS TO CREATE AN APPROX CLASS  @@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//

  approx * M;

  //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&//
  //&&&&& 1.) A MATRIX FILE &&&&&//
  //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&//
  if (matrix_file != NULL) 
    {    
      M=new  approx(order,length, matrix_file,alphabet_file,fr,r);
    }
  
  //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&//
  //&&&&& 2.) A SEQUENCE FILE &&&&&//
  //&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&//
  else
    {
      //@@@@@ Transition matrix estimated on sequence file
      M=new approx(order,fr,sequence_file,alphabet_file,r); 
    }
  length=M->tell_length();



  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@  METHODS OF MIGUEL ABADI  @@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
   
  if (in>=0)
    { 
      M->print_error_k(words_file,in,fr);
      M->psi_print_error_k(words_file,in,fr);
    }
  if(inf>=0)
    {
      M->print_k_sum_errors(words_file,inf,fr);
      M->psi_print_k_sum_errors(words_file,inf,fr);
    }
  if(sup>=0)
    {
      M->print_sum_errors_k(words_file,sup,fr);
      M->psi_print_sum_errors_k(words_file,sup,fr);
    }

  if((over==1)||(under==1)||(cs==1)||(ct==1))
    {
      //Open u file
      ofstream fu;
      fu.open(u_file); 

      //@@@@@  COUNT OF WORDS  @@@@@//
            
      //Count of each words in each sequence
      if ((ct==1)&&(sequence_file != NULL))
	{ 
	  M->count_words(words_file, sequence_file, alphabet_file, fu);
	}
      
      if((over==1)||(under==1)||(cs==1))
	{
	  fu<<endl
	    <<"###########################################"<<endl
	    <<"##   DIFFERENT U FOR DIFFERENT METHODS   ##"<<endl
	    <<"###########################################"<<endl
	    <<endl;
	}
      
      if(over==1)
	{
	  if (ds<0)
	    {
	      cerr<<"-ds <ds>0> ?"<<endl;
	      return 1;
	    }
	  M->print_u(words_file,ds,fr,fu);
	  M->psi_print_u(words_file,ds,fr,fu);
	}
      if(under==1)
	{
	  if (ds<0)
	    {
	      cerr<<"-ds <ds>0> ?"<<endl;
	      return 1;
	    }
	  M->u_print(words_file,ds,fr,fu);
	  M->psi_u_print(words_file,ds,fr,fu);
	}
      
      //$$$$$$$$$$$$$$$$$
      //$$$$$ USE R $$$$$
      //$$$$$$$$$$$$$$$$$
      
      if(cs ==1)
	{
	  if (ds<0)
	    {
	      cerr<<"-ds <ds>0> ?"<<endl;
	      return 1;
	    }
	  if(over == 1)
	    {
	      M->chenstein_over_ma(words_file,ds,fr,fu);
	    }
	  if(under == 1)
	    {
	      M->chenstein_under_ma(words_file,ds,fr,fu);
	    }
	}
      //Close u file
      fu.close(); 
    }

  //Close result file
  fr.close();
  
  return 1; 
}

